<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_PickUpPoint ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_PickUpPoint extends AbstractStructArrayBase
{
    /**
     * The PickUpPoint
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_PickUpPoint[]
     */
    public $PickUpPoint;
    /**
     * Constructor method for ArrayOfJPSOAP_PickUpPoint
     * @uses ArrayOfJPSOAP_PickUpPoint::setPickUpPoint()
     * @param \StructType\JPSOAP_PickUpPoint[] $pickUpPoint
     */
    public function __construct(array $pickUpPoint = array())
    {
        $this
            ->setPickUpPoint($pickUpPoint);
    }
    /**
     * Get PickUpPoint value
     * @return \StructType\JPSOAP_PickUpPoint[]|null
     */
    public function getPickUpPoint()
    {
        return $this->PickUpPoint;
    }
    /**
     * This method is responsible for validating the values passed to the setPickUpPoint method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPickUpPoint method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePickUpPointForArrayConstraintsFromSetPickUpPoint(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJPSOAP_PickUpPointPickUpPointItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_PickUpPointPickUpPointItem instanceof \StructType\JPSOAP_PickUpPoint) {
                $invalidValues[] = is_object($arrayOfJPSOAP_PickUpPointPickUpPointItem) ? get_class($arrayOfJPSOAP_PickUpPointPickUpPointItem) : sprintf('%s(%s)', gettype($arrayOfJPSOAP_PickUpPointPickUpPointItem), var_export($arrayOfJPSOAP_PickUpPointPickUpPointItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PickUpPoint property can only contain items of type \StructType\JPSOAP_PickUpPoint, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PickUpPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_PickUpPoint[] $pickUpPoint
     * @return \ArrayType\ArrayOfJPSOAP_PickUpPoint
     */
    public function setPickUpPoint(array $pickUpPoint = array())
    {
        // validation for constraint: array
        if ('' !== ($pickUpPointArrayErrorMessage = self::validatePickUpPointForArrayConstraintsFromSetPickUpPoint($pickUpPoint))) {
            throw new \InvalidArgumentException($pickUpPointArrayErrorMessage, __LINE__);
        }
        $this->PickUpPoint = $pickUpPoint;
        return $this;
    }
    /**
     * Add item to PickUpPoint value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_PickUpPoint $item
     * @return \ArrayType\ArrayOfJPSOAP_PickUpPoint
     */
    public function addToPickUpPoint(\StructType\JPSOAP_PickUpPoint $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_PickUpPoint) {
            throw new \InvalidArgumentException(sprintf('The PickUpPoint property can only contain items of type \StructType\JPSOAP_PickUpPoint, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PickUpPoint[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_PickUpPoint|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PickUpPoint
     */
    public function getAttributeName()
    {
        return 'PickUpPoint';
    }
}
